-- ARCHIVO CON LAS ACTUALIZACIONES DE DATA DE SQL PARA MIGRAR AL NUEVO BUILD DEL NOMBRE DE LA CARPETA
-- DECLARAMOS DOS VARIABLES, UNA CON LA VERSION DE LA QUE PARTIMOS Y OTRA CON LA NUEVA VERSION QUE ESTAMOS APUNTANDO
DECLARE @OLD_DATABASE_BUILD_VERSION VARCHAR(50) = '1.4.2'
DECLARE @NEW_DATABASE_BUILD_VERSION VARCHAR(50) = '1.5.0'

-- INICIAMOS UN TRY PARA EL CASO CAIGA EN CATCH HAGAMOS ROLLBACK
BEGIN TRY
    -- VALIDAMOS QUE LA VERSION EXISTENTE COINCIDE CON NUESTRA NEW_DATABASE_BUILD_VERSION
    IF NOT EXISTS (
        SELECT 1 
            FROM [dbo].[Version] V 
            WHERE V.[BuildVersion] = @OLD_DATABASE_BUILD_VERSION
    )	
        -- LANZAMOS UN MENSAJE DE ERROR INDICANDO QUE LA VERSION ACTUAL NO COINCIDE CON LA OLD_DATABASE_BUILD_VERSION
        RAISERROR('DATABASE_ERROR_INCORRECT_TARGET_VERSION', 16, 16)
        
    -- INICIAMOS LA TRANSACCION
    BEGIN TRANSACTION





    -- AQUI EMPIEZA LA SECCION CON LOS INSERT/UPDATE/DELETE PARA LA NUEVA VERSION

                
                --ACTUALIZAR LA PLANTILLA POR DEFECTO A ESPAÑOL
                UPDATE [dbo].[Template] SET [Name]='es_banca_template' WHERE [VCC] = 'system' AND [Type] = 'system'

                UPDATE [dbo].[TemplateTheme] SET [TemplateId] = 'es_banca_template' WHERE [TemplateId] = 'banca_template' AND [VCC] = 'system'

                UPDATE [dbo].[TemplateThemeItem] SET [TemplateId] =  'es_banca_template' WHERE [TemplateId] = 'banca_template' AND [VCC] = 'system'

                --INSERTAR PLANTILLA PARA INGLÉS
                INSERT [dbo].[Template] ([VCC], [Name], [Type], [Description], [Template], [Category], [CreatedDate], [CreatedByUserId], [LastModifiedDate], [LastModifiedByUserId], [TimeStamp]) VALUES (N'system', N'en_template', N'system', N'GSS_TEMPLATE', NULL, N'Banca', GETUTCDATE(), N'analytic', GETUTCDATE(), N'analytic', GETUTCDATE())

                INSERT [dbo].[TemplateTheme] ([VCC], [TemplateId], [ID], [Order], [Description], [Category1], [Category2], [CreatedDate], [CreatedByUserId], [LastModifiedDate], [LastModifiedByUserId], [TimeStamp]) VALUES (N'system', N'en_template', NEWID(), 1, N'Chance', N'Calling again', N'End of the month', GETUTCDATE(), N'analytic', GETUTCDATE(), N'analytic', GETUTCDATE())
                INSERT [dbo].[TemplateTheme] ([VCC], [TemplateId], [ID], [Order], [Description], [Category1], [Category2], [CreatedDate], [CreatedByUserId], [LastModifiedDate], [LastModifiedByUserId], [TimeStamp]) VALUES (N'system', N'en_template', NEWID(), 1, N'Three lines', N'Line', NULL, GETUTCDATE(), N'analytic', GETUTCDATE(), N'analytic', GETUTCDATE())
                INSERT [dbo].[TemplateTheme] ([VCC], [TemplateId], [ID], [Order], [Description], [Category1], [Category2], [CreatedDate], [CreatedByUserId], [LastModifiedDate], [LastModifiedByUserId], [TimeStamp]) VALUES (N'system', N'en_template', NEWID(), 1, N'Huawei', N'Line', N'Want team', GETUTCDATE(), N'analytic', GETUTCDATE(), N'analytic', GETUTCDATE())
                INSERT [dbo].[TemplateTheme] ([VCC], [TemplateId], [ID], [Order], [Description], [Category1], [Category2], [CreatedDate], [CreatedByUserId], [LastModifiedDate], [LastModifiedByUserId], [TimeStamp]) VALUES (N'system', N'en_template', NEWID(), 3, N'Others', N'Calling again', N'End of the month', GETUTCDATE(), N'analytic', GETUTCDATE(), N'analytic', GETUTCDATE())
                INSERT [dbo].[TemplateTheme] ([VCC], [TemplateId], [ID], [Order], [Description], [Category1], [Category2], [CreatedDate], [CreatedByUserId], [LastModifiedDate], [LastModifiedByUserId], [TimeStamp]) VALUES (N'system', N'en_template', NEWID(), 2, N'February', N'Calling again', NULL, GETUTCDATE(), N'analytic', GETUTCDATE(), N'analytic', GETUTCDATE())
                INSERT [dbo].[TemplateTheme] ([VCC], [TemplateId], [ID], [Order], [Description], [Category1], [Category2], [CreatedDate], [CreatedByUserId], [LastModifiedDate], [LastModifiedByUserId], [TimeStamp]) VALUES (N'system', N'en_template', NEWID(), 4, N'Do not call', NULL, NULL, GETUTCDATE(), N'analytic', GETUTCDATE(), N'analytic', GETUTCDATE())
                INSERT [dbo].[TemplateTheme] ([VCC], [TemplateId], [ID], [Order], [Description], [Category1], [Category2], [CreatedDate], [CreatedByUserId], [LastModifiedDate], [LastModifiedByUserId], [TimeStamp]) VALUES (N'system', N'en_template', N'60B6651D-1619-41CD-9FAD-BEF7E7D502D7', 1, N'Want to stay', N'You are with another operator', NULL, GETUTCDATE(), N'analytic', GETUTCDATE(), N'analytic', GETUTCDATE())
                INSERT [dbo].[TemplateTheme] ([VCC], [TemplateId], [ID], [Order], [Description], [Category1], [Category2], [CreatedDate], [CreatedByUserId], [LastModifiedDate], [LastModifiedByUserId], [TimeStamp]) VALUES (N'system', N'en_template', NEWID(), 2, N'At this time', N'Calling again', N'End of the month', GETUTCDATE(), N'analytic', GETUTCDATE(), N'analytic', GETUTCDATE())
                INSERT [dbo].[TemplateTheme] ([VCC], [TemplateId], [ID], [Order], [Description], [Category1], [Category2], [CreatedDate], [CreatedByUserId], [LastModifiedDate], [LastModifiedByUserId], [TimeStamp]) VALUES (N'system', N'en_template', NEWID(), 1, N'Nokia', N'Line', N'Buys', GETUTCDATE(), N'analytic', GETUTCDATE(), N'analytic', GETUTCDATE())
                INSERT [dbo].[TemplateTheme] ([VCC], [TemplateId], [ID], [Order], [Description], [Category1], [Category2], [CreatedDate], [CreatedByUserId], [LastModifiedDate], [LastModifiedByUserId], [TimeStamp]) VALUES (N'system', N'en_template', NEWID(), 4, N'Latest', N'Line', NULL, GETUTCDATE(), N'analytic', GETUTCDATE(), N'analytic', GETUTCDATE())

                INSERT [dbo].[TemplateThemeItem] ([VCC], [TemplateId], [TemplateThemeId], [ID], [CreatedDate], [CreatedByUserId], [LastModifiedDate], [LastModifiedByUserId], [TimeStamp]) VALUES (N'system', N'en_template', N'60B6651D-1619-41CD-9FAD-BEF7E7D502D7', N'I buy', GETUTCDATE(), N'analytic', GETUTCDATE(), N'analytic2', GETUTCDATE())
                INSERT [dbo].[TemplateThemeItem] ([VCC], [TemplateId], [TemplateThemeId], [ID], [CreatedDate], [CreatedByUserId], [LastModifiedDate], [LastModifiedByUserId], [TimeStamp]) VALUES (N'system', N'en_template', N'60B6651D-1619-41CD-9FAD-BEF7E7D502D7', N'Hello', GETUTCDATE(), N'analytic', GETUTCDATE(), N'analytic', GETUTCDATE())
                
                --INSERTAR CONSULTAS GENERICAS EN INGLÉS
                UPDATE [dbo].[GenericQuery] SET [Name] = 'es_hola' WHERE [VCC] = 'system' AND [Name] = 'hola'
                UPDATE [dbo].[GenericQuery] SET [Name] = 'es_compro' WHERE [VCC] = 'system' AND [Name] = 'compro'
                
                INSERT [dbo].[GenericQuery] ([VCC], [Name], [Description], [Query], [RawData], [CreatedDate], [CreatedByUserId], [LastModifiedDate], [LastModifiedByUserId], [TimeStamp],[Version]) VALUES (N'system', N'en_hello', N'hello', N'(hello NEAR_5 good)', N'[{"queryDescription2":"good","queryDescription":"hello ","filter":"NEAR","open":"","close":"","fieldDescription":"Near to 5 Words from ","operatorDescription":"","operator":"","scope":"TEXT_ALL","scopeDescription":"General Text","rangeFrom":"","rangeTo":"","query":"(\\\"hello\\\" NEAR_5 \\\"good\\\")"}]', GETUTCDATE(), N'analytic', GETUTCDATE(), N'analytic', GETUTCDATE(),2)
                INSERT [dbo].[GenericQuery] ([VCC], [Name], [Description], [Query], [RawData], [CreatedDate], [CreatedByUserId], [LastModifiedDate], [LastModifiedByUserId], [TimeStamp],[Version]) VALUES (N'system', N'en_buy', N'buy', N'\"line\"', N'[{"queryDescription2":"","queryDescription":"line","filter":"TEXT","open":"","close":"","fieldDescription":"Text ","operatorDescription":"","operator":"","scope":"TEXT_ALL","scopeDescription":"General Text","rangeFrom":"","rangeTo":"","query":"\\\"line\\\""}]', GETUTCDATE(), N'analytic', GETUTCDATE(), N'analytic', GETUTCDATE(),2)

                --INSERTAR TRADUCCIONES
                INSERT [dbo].[WordsByLanguage] ([Label],[Language],[Word]) VALUES('ENVIRONMENT','es','Ambiente')
                INSERT [dbo].[WordsByLanguage] ([Label],[Language],[Word]) VALUES('ENVIRONMENT','en','Envinronment')


                UPDATE [dbo].[Role] SET [Description] = 'administrator' WHERE [ID] = 'administrator'
    -- AQUI TERMINA LA SECCION CON LOS INSERT/UPDATE/DELETE PARA LA NUEVA VERSION



    

    -- TERMINAMOS LA ACTUALIZACION DE DATA ACTUALIZANDO EL BUILDVERSION
    UPDATE [dbo].[Version] 
        SET [BuildVersion] = @NEW_DATABASE_BUILD_VERSION, 
            [IsRegistered] = 0,
            [TimeStamp] = GETUTCDATE() 
        WHERE [BuildVersion] = @OLD_DATABASE_BUILD_VERSION
    PRINT 'UPDATED_DATABASE_BUILD_VERSION'

    -- COMPLETAMOS LA TRANSACCION
    COMMIT TRANSACTION
END TRY
BEGIN CATCH
    IF @@TRANCOUNT > 0 ROLLBACK TRANSACTION

    DECLARE @Message nvarchar(2048) = ERROR_MESSAGE()
    DECLARE @Severity integer = ERROR_SEVERITY()
    DECLARE @State integer = ERROR_STATE()

    RAISERROR(@Message, @Severity, @State)
    --RETURN -1
END CATCH



